function convertTextScaling() {
    var doc = app.activeDocument;

    // Создаем окно диалога
    var dialog = new Window("dialog", "Преобразование текста");
    dialog.alignChildren = "left";

    // Добавляем описание
    dialog.add("statictext", undefined, "Преобразование вертикального масштабирования текста к 100 %");

    var checkboxAllText = dialog.add("checkbox", undefined, "Преобразовать весь текст в документе");
    var checkboxSelectedText = dialog.add("checkbox", undefined, "Преобразовать только выделенный текст");

    // Настраиваем переключение доступности чек-боксов
    checkboxAllText.onClick = function () {
        checkboxSelectedText.enabled = !checkboxAllText.value;
    };
    checkboxSelectedText.onClick = function () {
        checkboxAllText.enabled = !checkboxSelectedText.value;
    };

    var buttonGroup = dialog.add("group");
    buttonGroup.alignment = "right";
    buttonGroup.add("button", undefined, "OK", { name: "ok" });
    buttonGroup.add("button", undefined, "Отмена", { name: "cancel" });

    var userChoice = dialog.show();

    if (userChoice !== 1) {
        alert("Преобразование отменено.");
        return;
    }

    var items;
    if (checkboxAllText.value) {
        // Преобразование всего текста
        items = doc.textFrames;
    } else if (checkboxSelectedText.value) {
        // Преобразование только выделенного текста
        items = app.selection;
    } else {
        alert("Вы не выбрали ни одного варианта.");
        return;
    }

    if (items.length === 0) {
        alert("Нет текстовых объектов для преобразования.");
        return;
    }

    var hasVerticalScaleIssue = false;

    for (var i = 0; i < items.length; i++) {
        var textFrame = items[i];

        if (textFrame.textRange) {
            var verticalScale = textFrame.textRange.characterAttributes.verticalScale;
            var fontSize = textFrame.textRange.characterAttributes.size;

            if (verticalScale !== 100) {
                hasVerticalScaleIssue = true;
                var newFontSize = fontSize * (verticalScale / 100);
                var newHorizontalScale = 100 * (textFrame.textRange.characterAttributes.horizontalScale / verticalScale);

                textFrame.textRange.characterAttributes.verticalScale = 100;
                textFrame.textRange.characterAttributes.size = newFontSize;
                textFrame.textRange.characterAttributes.horizontalScale = newHorizontalScale;
            }
        }
    }

    if (!hasVerticalScaleIssue) {
        alert("Текст с вертикальным масштабированием, отличным от 100 %, отсутствует.");
    } else {
        alert("Преобразование завершено!");
    }
}

convertTextScaling();
